BaleWrapperStateEvent = {}
BaleWrapperStateEvent_mt = Class(BaleWrapperStateEvent, Event)
InitEventClass(BaleWrapperStateEvent, "BaleWrapperStateEvent")
function BaleWrapperStateEvent:emptyNew()
  local self = Event:new(BaleWrapperStateEvent_mt)
  return self
end
function BaleWrapperStateEvent:new(object, stateId, nearestBaleServerId)
  local self = BaleWrapperStateEvent:emptyNew()
  self.object = object
  self.stateId = stateId
  assert(nearestBaleServerId ~= nil or self.stateId ~= BaleWrapper.CHANGE_GRAB_BALE)
  self.nearestBaleServerId = nearestBaleServerId
  return self
end
function BaleWrapperStateEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId))
  self.stateId = streamReadInt8(streamId)
  if self.stateId == BaleWrapper.CHANGE_GRAB_BALE then
    self.nearestBaleServerId = streamReadInt32(streamId)
  end
  self:run(connection)
end
function BaleWrapperStateEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object))
  streamWriteInt8(streamId, self.stateId)
  if self.stateId == BaleWrapper.CHANGE_GRAB_BALE then
    streamWriteInt32(streamId, self.nearestBaleServerId)
  end
end
function BaleWrapperStateEvent:run(connection)
  self.object:doStateChange(self.stateId, self.nearestBaleServerId)
end
