local modFilename, isMod, isDlc, dlcsDirectoryIndex = Utils.removeModDirectory(g_currentModDirectory)
if not _G.g_clientPSShovelFixEnabled then
  _G.g_clientPSShovelFixEnabled = true

    local Shovel_load = Shovel.load
    function Shovel:load(xmlFile)
      Shovel_load(self, xmlFile)
      if self.shovelDirtyFlag == nil then
        self.shovelDirtyFlag = self:getNextDirtyFlag()
      end
      self.lastShovelPSFillDelta = 0
      self.lastShovelPSFillType = Fillable.FILLTYPE_UNKNOWN
    end
    local Shovel_readUpdateStream = Shovel.readUpdateStream
    function Shovel:readUpdateStream(streamId, timestamp, connection)
      if Shovel_readUpdateStream ~= nil then
        Shovel_readUpdateStream(self, streamId, timestamp, connection)
      end
      if connection:getIsServer() and streamReadBool(streamId) then
        local fillLevelDelta = streamReadFloat32(streamId)
        local fillType = streamReadUIntN(streamId, Fillable.sendNumBits)
        self:updateShovelParticleSystems(fillLevelDelta, fillType)
      end
    end
    local Shovel_writeUpdateStream = Shovel.writeUpdateStream
    function Shovel:writeUpdateStream(streamId, connection, dirtyMask)
      if Shovel_writeUpdateStream ~= nil then
        Shovel_writeUpdateStream(self, streamId, connection, dirtyMask)
      end
      if not connection:getIsServer() then
        if streamWriteBool(streamId, bitAND(dirtyMask, self.shovelDirtyFlag) ~= 0 and self.lastShovelPSFillDelta ~= 0) then
          streamWriteFloat32(streamId, self.lastShovelPSFillDelta)
          streamWriteUIntN(streamId, self.lastShovelPSFillType, Fillable.sendNumBits)
        end
      end
    end
    local Shovel_updateShovelParticleSystems = Shovel.updateShovelParticleSystems
    function Shovel:updateShovelParticleSystems(fillLevelDelta, fillType)
      Shovel_updateShovelParticleSystems(self, fillLevelDelta, fillType)
      if self.isServer then
        self:raiseDirtyFlags(self.shovelDirtyFlag)
        self.lastShovelPSFillDelta = fillLevelDelta
        self.lastShovelPSFillType = fillType
      end
    end

end
